!--------------------------------------------------------------------------
! (c) 1996 thru 2003 by
! Tinman Development Corporation
!                And
! Reichenberger Development Incorporated
! All Rights Reserved World Wide
! ISBN: 0-933735-17-0
! 
!--------------------------------------------------------------------------

  MEMBER()

  INCLUDE('Tintrptv.inc')
  INCLUDE('TplEqu.Clw')
  INCLUDE('PRNPROP.CLW')
  INCLUDE('Keycodes.CLW')
  INCLUDE('Equates.CLW')

  MAP
  OMIT('***',_WIDTH32_)
  ***
  COMPILE('***',_WIDTH32_)
  ***
!   MODULE('WMFTXTX.LIB')
!     wmf2asc(STRING,FILE,*STRING)
!   END
  END


TinReportViewer.MarkQueueInit PROCEDURE
  CODE
   SELF.ImageCount    = RECORDS(SELF.ImageQueue)
   SELF.MarkQueue &= NEW MarkQueueType
   SELF.MarkQueue.Mark = 0
   LOOP Records(SELF.ImageQueue) Times
     ADD(SELF.MarkQueue)
   END
   SELF.TempImageQueue &= NEW TinPreviewQueue
   SELF.WorkImageQueue &= NEW TinPreviewQueue

TinReportViewer.MarkQueueKill PROCEDURE
  CODE
   Assert(~SELF.MarkQueue &= NULL)
   IF ~SELF.MarkQueue &= NULL
     FREE(SELF.MarkQueue)
     DISPOSE(SELF.MarkQueue)
   END
   Assert(~SELF.TempImageQueue &= NULL)
   IF ~SELF.TempImageQueue &= NULL
     FREE(SELF.TempImageQueue)
     DISPOSE(SELF.TempImageQueue)
   END
   Assert(~SELF.WorkImageQueue &= NULL)
   IF ~SELF.WorkImageQueue &= NULL
     FREE(SELF.WorkImageQueue)
     DISPOSE(SELF.WorkImageQueue)
   END


TinReportViewer.MarkQueueCheck PROCEDURE
 CODE
  GET(SELF.MarkQueue,SELF.CurrentPage)
  IF SELF.MarkQueue.Mark
    SELF.PreviewMark{Prop:ICON} = ICON:CROSS
    SELF.PreviewMark{Prop:Msg}  = 'Unmark Page'
    SELF.PreviewWindow{Prop:StatusText,4} = 'Marked'
  ELSE
    SELF.PreviewMark{Prop:ICON} = ICON:TICK
    SELF.PreviewMark{Prop:Msg}  = 'Mark Page'
    SELF.PreviewWindow{Prop:StatusText,4} = ''
  END

TinReportViewer.MarkQueueMarkPage PROCEDURE
 CODE
  IF SELF.MarkQueue.Mark
    SELF.PageMarked -= 1
    SELF.MarkQueue.Mark = False
  ELSE
    SELF.PageMarked += 1
    SELF.MarkQueue.Mark = True
  END
  PUT(SELF.MarkQueue)
  SELF.MarkQueueCheck

TinReportViewer.DeletePage PROCEDURE
 CODE
  GET(SELF.ImageQueue,SELF.CurrentPage)
  Remove(SELF.ImageQueue)
  GET(SELF.MarkQueue,SELF.CurrentPage)
  DELETE(SELF.ImageQueue)
  DELETE(SELF.MarkQueue)
  SELF.ImageCount = Records(SELF.ImageQueue)
  IF SELF.CurrentPage <> 1 THEN
    SELF.CurrentPage -= 1
  END

TinReportViewer.ZoomQueueInit PROCEDURE
i USHORT,AUTO
  CODE
   SELF.ZoomQueue &= NEW ZoomQueueType
   SELF.ZoomQueue.ZoomAmount = 'No Zoom'
   SELF.ZoomStatus = 'No Zoom'
   SELF.ZoomQueue.ZoomModifier = 0
   SELF.ZoomQueue.ZoomHScroll  = False
   ADD(SELF.ZoomQueue)
   SELF.ZoomQueue.ZoomAmount = 'Page Width'
   SELF.ZoomQueue.ZoomModifier = SELF.PreviewWindow{Prop:Width} / SELF.ImageWidth
   SELF.ZoomQueue.ZoomHScroll  = False
   ADD(SELF.ZoomQueue)
   SELF.ZoomQueue.ZoomAmount = 'Zoom (50%)'
   SELF.ZoomQueue.ZoomModifier = .50
   SELF.ZoomQueue.ZoomHScroll  = True
   ADD(SELF.ZoomQueue)
   SELF.ZoomQueue.ZoomAmount = 'Zoom (75%)'
   SELF.ZoomQueue.ZoomModifier = .75
   SELF.ZoomQueue.ZoomHScroll  = True
   ADD(SELF.ZoomQueue)
   SELF.ZoomQueue.ZoomAmount = 'Zoom (100%)'
   SELF.ZoomQueue.ZoomModifier = 1
   SELF.ZoomQueue.ZoomHScroll  = True
   ADD(SELF.ZoomQueue)
   SELF.ZoomQueue.ZoomAmount = 'Zoom (200%)'
   SELF.ZoomQueue.ZoomModifier = 2
   SELF.ZoomQueue.ZoomHScroll  = True
   ADD(SELF.ZoomQueue)
   SELF.ZoomQueue.ZoomAmount = 'Zoom (300%)'
   SELF.ZoomQueue.ZoomModifier = 3
   SELF.ZoomQueue.ZoomHScroll  = True
   ADD(SELF.ZoomQueue)
   LOOP i=1 TO RECORDS(SELF.ZoomQueue)
    GET(SELF.ZoomQueue,i)
    !ASSERT(~ERRORCODE())
    SELF.ZoomList{PROP:From}=CLIP(SELF.ZoomList{PROP:From})&CLIP(SELF.ZoomQueue.ZoomAmount)&CHOOSE(i<RECORDS(SELF.ZoomQueue),'|','')
   END

TinReportViewer.ZoomQueueKill PROCEDURE
  CODE
   Assert(~SELF.ZoomQueue &= NULL)
   IF ~SELF.ZoomQueue &= NULL
     FREE(SELF.ZoomQueue)
     DISPOSE(SELF.ZoomQueue)
   END

TinReportViewer.ZoomQueueFindEntry PROCEDURE
i Ushort
  CODE
   LOOP i#=1 TO RECORDS(SELF.ZoomQueue)
     GET(SELF.ZoomQueue,i#)
     IF Clip(SELF.ZoomQueue.ZoomAmount) = Clip(SELF.ZoomStatus) Then
       Break
     END
   END

TinReportViewer.CreateZoomControl PROCEDURE
  CODE
  CREATE(TinRV:ZoomBorder,CREATE:Box)
  SETPOSITION(TinRV:ZoomBorder,0,0)
  TinRV:ZoomBorder{Prop:Color} = 0
  TinRV:ZoomBorder{Prop:Fill} = 0FFFFFFh
  TinRV:ZoomBorder{Prop:Full} = True
  UNHIDE(TinRV:ZoomBorder)
  CREATE(TinRV:ZoomImage,CREATE:Image)
  SETPOSITION(TinRV:ZoomImage,0,0)
  TinRV:ZoomImage{Prop:VScroll} = True
  TinRV:ZoomImage{Prop:HScroll} = True
  TinRV:ZoomImage{Prop:Full} = True
  TinRV:ZoomImage{Prop:FillColor} = 0FFFFFFh    !***This statement was missing***
  TinRV:ZoomImage{Prop:Alrt} = MouseLeft
  TinRV:ZoomImage{Prop:Cursor} = Cursor:Zoom
  UNHIDE(TinRV:ZoomImage)
  SELF.ZoomControlPresent = True

TinReportViewer.DestroyZoomControl PROCEDURE
 CODE
  HIDE(TinRV:ZoomBorder)
  HIDE(TinRV:ZoomImage)
  DESTROY(TinRV:ZoomBorder)
  DESTROY(TinRV:ZoomImage)
  SELF.ZoomControlPresent = False

TinReportViewer.FillZoomControl PROCEDURE
 CODE
  MTSaveVPos# = TinRV:ZoomImage{prop:vScrollPos}
  MTSaveHPos# = TinRV:ZoomImage{prop:hScrollPos}
  GET(SELF.ImageQueue,SELF.CurrentPage)
  TinRV:ZoomImage{Prop:Text} = SELF.ImageQueue
  SELF.PreviewWindow{Prop:StatusText,5} = 'Page ' & SELF.CurrentPage & ' of ' & SELF.ImageCount
  TinRV:ZoomImage{Prop:MaxWidth} = SELF.ImageWidth * SELF.ZoomQueue.ZoomModifier
  TinRV:ZoomImage{Prop:MaxHeight} = SELF.ImageHeight * SELF.ZoomQueue.ZoomModifier
  TinRV:ZoomImage{prop:vScrollPos} = MTSaveVPos#
  TinRV:ZoomImage{prop:hScrollPos} = MTSaveHPos#
  TinRV:ZoomImage{Prop:HScroll}    = SELF.ZoomQueue.ZoomHScroll
  IF SELF.ImageCount > 1
    ! change
    IF SELF.CurrentPage = 1
      DISABLE(SELF.Previous)
      disable(Self.Previous - 1)
    ELSE
      ENABLE(SELF.Previous)
      enable(Self.Previous - 1)
    END
    IF SELF.CurrentPage >= SELF.ImageCount
      DISABLE(SELF.Next)
      disable(Self.Next + 1)
    ELSE
      ENABLE(SELF.Next)
      enable(Self.Next + 1)
    END
    ! end change
  END

TinReportViewer.GetNextPage PROCEDURE
 CODE
   IF SELF.ZoomStatus = 'No Zoom'
     IF SELF.CurrentPage + SELF.ThumbnailsPresent <= SELF.ImageCount
       SELF.CurrentPage += SELF.ThumbnailsPresent
     END
   ELSE
     IF SELF.CurrentPage <> SELF.ImageCount
       SELF.CurrentPage += 1
     END
   END

TinReportViewer.GetPrevPage PROCEDURE
 CODE
   IF SELF.ZoomStatus = 'No Zoom'
     SELF.CurrentPage -= SELF.ThumbnailsPresent
     IF SELF.CurrentPage < 1
       SELF.CurrentPage = 1
     END
   ELSE
     IF SELF.CurrentPage <> 1
       SELF.CurrentPage -= 1
     END
   END

TinReportViewer.CreateThumbnails PROCEDURE
 CODE
   !SELF.ZoomRatio = 'No Zoom'
   SELF.CurrentBorderBox = TinRV:LowestBorderEquate
   SELF.CurrentImageBox = TinRV:LowestImageEquate
   SELF.ThumbnailsRequired = (SELF.PagesAcross * SELF.PagesDown)
   LOOP SELF.CurrentThumbnail = 1 TO SELF.ThumbnailsRequired
     CREATE(SELF.CurrentBorderBox,CREATE:Box)
     CREATE(SELF.CurrentImageBox,CREATE:Image)
     SELF.CurrentBorderBox += 1
     SELF.CurrentImageBox += 1
   END
   SELF.ThumbnailsPresent = SELF.ThumbnailsRequired

TinReportViewer.DestroyThumbnails PROCEDURE
 CODE
   HIDE(TinRV:LowestBorderEquate,TinRV:HighestControlEquate)
   DESTROY(TinRV:LowestImageEquate,TinRV:HighestControlEquate)
   SELF.ThumbnailsPresent = 0

TinReportViewer.PositionThumbnails PROCEDURE
 CODE
   SELF.TotalXSeparation = 2 + ((SELF.PagesAcross - 1) * TinRV:MinimumXSeparation)
   SELF.TotalYSeparation = 2 + ((SELF.PagesDown - 1) * TinRV:MinimumYSeparation)
   SELF.ThumbnailWidth = (TARGET{Prop:Width} - SELF.TotalXSeparation) / SELF.PagesAcross
   SELF.ThumbnailHeight = ((TARGET{Prop:Height} -18) - SELF.TotalYSeparation) / SELF.PagesDown
   SELF.ThumbnailAspectRatio = SELF.ThumbnailHeight / SELF.ThumbnailWidth
   IF SELF.ThumbnailAspectRatio < SELF.ImageAspectRatio
     SELF.ThumbnailWidth = SELF.ThumbnailHeight / SELF.ImageAspectRatio
   ELSE
     SELF.ThumbnailHeight = SELF.ThumbnailWidth * SELF.ImageAspectRatio
   END
   SELF.CurrentBorderBox = TinRV:LowestBorderEquate
   SELF.CurrentImageBox = TinRV:LowestImageEquate
   SELF.ThumbnailYPosition = 1
   LOOP SELF.ThumbnailRow = 1 TO SELF.PagesDown
     SELF.ThumbnailXPosition = 1
     LOOP SELF.ThumbnailColumn = 1 TO SELF.PagesAcross
       SETPOSITION(SELF.CurrentBorderBox,SELF.ThumbnailXPosition,SELF.ThumbnailYPosition,SELF.ThumbnailWidth,SELF.ThumbnailHeight)
       SETPOSITION(SELF.CurrentImageBox,SELF.ThumbnailXPosition,SELF.ThumbnailYPosition,SELF.ThumbnailWidth,SELF.ThumbnailHeight)
       SELF.CurrentBorderBox{Prop:Color} = 0
       SELF.CurrentBorderBox{Prop:Fill} = 0FFFFFFh
       SELF.CurrentImageBox{Prop:Cursor} = Cursor:Zoom
       SELF.CurrentImageBox{Prop:Alrt} = MouseLeft
       SELF.ThumbnailXPosition += TinRV:MinimumXSeparation + SELF.ThumbnailWidth
       SELF.CurrentBorderBox += 1
       SELF.CurrentImageBox += 1
     END
     SELF.ThumbnailYPosition += TinRV:MinimumYSeparation + SELF.ThumbnailHeight
   END

TinReportViewer.FillThumbnails PROCEDURE
 CODE

   SELF.CurrentBorderBox = TinRV:LowestBorderEquate
   SELF.CurrentImageBox = TinRV:LowestImageEquate
   LOOP SELF.CurrentThumbnail = 1 TO SELF.ThumbnailsPresent
     SELF.ProcessedPage = (SELF.CurrentPage + SELF.CurrentThumbnail) - 1
     IF SELF.ProcessedPage > SELF.ImageCount
       IF SELF.CurrentImageBox{Prop:Hide} = False
         HIDE(SELF.CurrentBorderBox)
         HIDE(SELF.CurrentImageBox)
       END
     ELSE
       GET(SELF.ImageQueue,SELF.ProcessedPage)
       SELF.CurrentImageBox{Prop:Text} = SELF.ImageQueue
       IF SELF.CurrentImageBox{Prop:Hide} = True
         UNHIDE(SELF.CurrentBorderBox)
         UNHIDE(SELF.CurrentImageBox)
       END
     END
     SELF.CurrentBorderBox += 1
     SELF.CurrentImageBox += 1
   END
   IF SELF.ImageCount > 1
     IF SELF.CurrentPage = 1
       DISABLE(SELF.Previous)
       disable(Self.Previous - 1)
     ELSE
       ENABLE(SELF.Previous)
       enable(Self.Previous - 1)
     END
     IF SELF.CurrentPage + SELF.ThumbnailsPresent > SELF.ImageCount
       DISABLE(SELF.Next)
     ELSE
       ENABLE(SELF.Next)
     END
   END
   IF SELF.ThumbnailsPresent > 1
     SELF.ProcessedPage = SELF.CurrentPage + SELF.ThumbnailsPresent - 1
     IF SELF.ProcessedPage > SELF.ImageCount
       SELF.ProcessedPage = SELF.ImageCount
     END
     IF SELF.CurrentPage = SELF.ImageCount
       SELF.PreviewWindow{Prop:StatusText,5} = 'Page ' & SELF.CurrentPage & ' of ' & SELF.ImageCount
     ELSE
       SELF.PreviewWindow{Prop:StatusText,5} = 'Pages ' & SELF.CurrentPage & '-' & SELF.ProcessedPage & ' of ' & SELF.ImageCount
     END
   ELSE
     SELF.PreviewWindow{Prop:StatusText,5} = 'Page ' & SELF.CurrentPage & ' of ' & SELF.ImageCount
   END

TinReportViewer.ChangeDisplay PROCEDURE

  CODE

  IF SELF.ZoomStatus = 'No Zoom'
    IF SELF.ZoomControlPresent
      SELF.DestroyZoomControl
    END
    IF SELF.PagesDown <> SELF.DisplayedPagesDown OR SELF.PagesAcross <> SELF.DisplayedPagesAcross
      IF SELF.ThumbnailsPresent
        SELF.DestroyThumbnails
      END
      SELF.CreateThumbnails
      SELF.DisplayedPagesDown = SELF.PagesDown
      SELF.DisplayedPagesAcross = SELF.PagesAcross
    END
    SELF.PositionThumbnails
    SELF.FillThumbnails
    IF (SELF.PagesAcross = 1 AND SELF.PagesDown = 1)
      SELF.MarkQueueCheck
    END
  ELSE   !Here For Zooming
    IF SELF.ThumbnailsPresent
      SELF.DestroyThumbnails
    END
    IF NOT SELF.ZoomControlPresent
      SELF.CreateZoomControl
    END
    SELF.FillZoomControl
    SELF.DisplayedPagesAcross = 0
    SELF.DisplayedPagesDown   = 0
    SELF.MarkQueueCheck
  END
  SELF.PreviewWindow{Prop:StatusText,2} = SELF.ZoomStatus
!  DISPLAY(?PagesDown)

TinReportViewer.Display PROCEDURE(Report Reportin, Queue ImageQueue, String Titlein, string ZoomAmount, byte MaxWindow)
! change to window format, arragnged buttons ?PreviewTop - ?PreviewBottom in sequence to
! allow easy enable/disable
Preview:Window WINDOW('Pregled'),AT(0,0,347,191),FONT('Tahoma',10),RESIZE,ALRT(PgUpKey), |
          ALRT(PgDnKey),ALRT(UpKey),ALRT(DownKey),ALRT(LeftKey),ALRT(RightKey),AUTO,COLOR(COLOR:Gray), |
          ICON(ICON:Print),GRAY,IMM,MAX,STATUS(150,50,50,50,-1),SYSTEM
          TOOLBAR,AT(0,0,347,18)
            BUTTON,AT(2,2,14,14),USE(?PrintButton),ICON(ICON:Print),MSG('Print The Report'), |
              TIP('Print The Report')
            BUTTON,AT(18,2,14,14),USE(?ExitButton),ICON(ICON:NoPrint),MSG('Exit Without' & |
              ' Printing Report'),TIP('Exit Without Printing Report')
            BUTTON,AT(114,2,14,14),USE(?JUMP),ICON(ICON:JumpPage),MSG('Jump To Page ??'),TIP('Jump To Page ??')
            BUTTON,AT(50,2,14,14),USE(?PREVIEWTOP),ICON(ICON:VCRtop),MSG('Go To First Page'), |
              TIP('Go To First Page')
            BUTTON,AT(66,2,14,14),USE(?PREVIOUS),ICON(ICON:VCRback),MSG('Previous Page'),TIP('Previous Page')
            BUTTON,AT(82,2,14,14),USE(?NEXT),ICON(ICON:VCRplay),MSG('Next Page'),TIP('Next Page')
            BUTTON,AT(98,2,14,14),USE(?PREVIEWBOTTOM),ICON(ICON:VCRbottom),MSG('Go To Last Page'), |
              TIP('Go To Last Page')
            BUTTON,AT(34,2,14,14),USE(?PrintSingle),ICON(ICON:Print1),MSG('Print Curren' & |
              't Page Only'),TIP('Print Current Page Only')
            BUTTON,AT(162,2,14,14),USE(?CHANGEDISPLAY),ICON(ICON:Thumbnail),MSG('Display Thumbnails'), |
              TIP('Display Thumbnails')
            COMBO(@s12),AT(263,4,51,9),USE(SELF.ZoomStatus,,?ZoomStatus),LEFT,DROP(7,40),FROM('No Zoom|Pa' & |
              'ge Width|Zoom (50%)|Zoom (75%)|Zoom (100%)|Zoom (200%)|Zoom (300%)'),MSG('Zoom Control'), |
              TIP('Zoom Control')
            BUTTON,AT(146,2,14,14),USE(?PREVIEWDELETE),ICON(ICON:Cut),MSG('Delete Page'),TIP('Delete Page')
            BUTTON,AT(130,2,14,14),USE(?PREVIEWMARK),ICON(ICON:New),MSG('Mark Page For Printing'), |
              TIP('Mark / Unmark Page For Printing')
          END
        END
   CODE
   Setcursor(CURSOR:WAIT)
   Display()
   SELF.ImageQueue    &= ImageQueue
   SELF.PreviewReport &= Reportin
   SELF.ReturnValue   = RequestCancelled
   SELF.ReportTitle   = CLIP(TITLEIN)
   SELF.CurrentPage          = 1
   SELF.PagesAcross          = 1
   SELF.PagesDown            = 1
   SELF.PagesDown            = 1
   SELF.DisplayedPagesAcross = 0
   SELF.DisplayedPagesDown   = 0
   SELF.ThumbnailsPresent    = 0
   SELF.ZoomControlPresent   = False
   SELF.SaveLandscape  = SELF.PreviewReport{prop:landscape}
   SELF.CurrentPrinter = PRINTER{PROPPRINT:Device}
   SELF.ImageCount     = RECORDS(SELF.ImageQueue)
   SELF.MarkQueueInit
   Setcursor()
   Display()
   OPEN(Preview:Window)
   SELF.PreviewWindow &= Preview:Window
   SELF.Previous       = ?Previous     !CONTROL
   SELF.Next           = ?Next         !CONTROL
   SELF.PreviewMark    = ?PreviewMark  !CONTROL
   SELF.Zoomlist       = ?ZoomStatus   !CONTROL
   IF CLIP(SELF.ReportTitle) <> '' THEN
     Preview:Window{Prop:Text} = CLIP(SELF.ReportTitle)
   END

   ! Change
   if MaxWindow
     Self.PreviewWindow{prop:Maximize} = '1'
   else
     SELF.PreviewWindow{Prop:MinWidth} = 345
     SELF.PreviewWindow{Prop:MinHeight} = 195
   end
   ! End Change

   ! Retrieve first image to get image aspect ratio, then destroy the image
   GET(SELF.ImageQueue,1)
   CREATE(TinRV:TemporaryImage,CREATE:Image)
   TinRV:TemporaryImage{Prop:Text} = SELF.ImageQueue
   SELF.ImageWidth = TinRV:TemporaryImage{Prop:MaxWidth}
   SELF.ImageHeight = TinRV:TemporaryImage{Prop:MaxHeight}
   SELF.ImageAspectRatio = SELF.ImageHeight / SELF.ImageWidth
   DESTROY(TinRV:TemporaryImage)
   SELF.ImageCount    = RECORDS(SELF.ImageQueue)
   IF SELF.ImageCount = 1
 !    DISABLE(?ViewMenu)
   END
   SELF.ZoomQueueInit
   SELF.CHECKFORPAGENUM
   SETCURSOR()
   DISPLAY

   ! Change
     Self.ZoomStatus = ZoomAmount
     SELF.ZoomQueueFindEntry
   ! End Change

   SELF.ChangeDisplay
   ACCEPT
     CASE EVENT()
     OF Event:Sized
       SELF.ChangeDisplay
     OF Event:NewSelection
     OF Event:Rejected
       CASE REJECTCODE()
       OF Reject:RangeHigh
         CHANGE(FIELD(),FIELD(){Prop:RangeHigh})
       OF Reject:RangeLow
         CHANGE(FIELD(),FIELD(){Prop:RangeLow})
       END
       SELF.ChangeDisplay
     OF Event:AlertKey
       CASE KEYCODE()
       OF PgUpKey
         POST(Event:Accepted,?Previous)
       OF PgDnKey
         POST(Event:Accepted,?Next)
       OF DownKey
         MTSaveVPos# = TinRV:ZoomImage{prop:vScrollPos}
         TinRV:ZoomImage{prop:vScrollPos} = MTSaveVPos# + 51
       OF UpKey
         MTSaveVPos# = TinRV:ZoomImage{prop:vScrollPos}
         TinRV:ZoomImage{prop:vScrollPos} = MTSaveVPos# - 51
       OF LeftKey
         MTSaveHPos# = TinRV:ZoomImage{prop:hScrollPos}
         TinRV:ZoomImage{prop:hScrollPos} = MTSaveHPos# - 52
       OF RightKey
         MTSaveHPos# = TinRV:ZoomImage{prop:hScrollPos}
         TinRV:ZoomImage{prop:hScrollPos} = MTSaveHPos# + 52
       ELSE
         CASE FIELD()
         OF TinRV:ZoomImage
           SELF.ZoomStatus = 'No Zoom'
           SELF.ZoomQueueFindEntry
           SELF.ChangeDisplay
         ELSE
           SELF.CurrentPage = (FIELD() - TinRV:LowestImageEquate) + SELF.CurrentPage
           SELF.ZoomStatus = 'Page Width'
           SELF.ZoomQueueFindEntry
           SELF.ChangeDisplay
         END
       END
     OF Event:Accepted
       CASE FIELD()
       OF ?PrintButton
         IF SELF.PrintReport() THEN
           SELF.ReturnValue = RequestCompleted
           POST(Event:CloseWindow)
         ELSE
           SELF.ReturnValue = RequestCancelled
           CYCLE
         END
       OF ?ExitButton
         SELF.ReturnValue = RequestCancelled
         !Tinman 07/16/99
         SELF.PreviewReport{PROP:FlushPreview} = False
         !Tinman 07/16/99
         SELF.UserCanceledReport = True  !User Canceled report
         POST(Event:CloseWindow)
       OF ?PrintSingle
         FREE(SELF.TempImageQueue)
         GET(SELF.ImageQueue,SELF.CurrentPage)
         SELF.TempImageQueue.FileName = SELF.ImageQueue
         ADD(SELF.TempImageQueue)
         SELF.PrintOther
       OF ?ZoomStatus
         SELF.ZoomQueueFindEntry
         SELF.ChangeDisplay
       OF ?Next
         SELF.GetNextPage
         SELF.ChangeDisplay
       OF ?Previous
        SELF.GetPrevPage
         SELF.ChangeDisplay
       OF ?Jump
         SELF.CurrentPage = SELF.JumpToPage(SELF.CurrentPage,SELF.ImageCount)
         SELF.ChangeDisplay
       OF ?ChangeDisplay
         SELF.SelectDisplay(SELF.PagesAcross,SELF.PagesDown)
         SELF.ZoomStatus = 'No Zoom'
         SELF.ZoomQueueFindEntry
         SELF.ChangeDisplay
       OF ?PreviewTop
         SELF.CurrentPage = 1
         POST(Event:Accepted,?Previous)
       OF ?PreviewBottom
         SELF.CurrentPage = SELF.ImageCount
         POST(Event:Accepted,?Next)
        OF ?PREVIEWMARK
          SELF.MarkQueueMarkPage
        OF ?PREVIEWDELETE
          SELF.DeletePage
          SELF.ChangeDisplay
  END
     END
   ?PreviewMark{Prop:Disable} = Choose((SELF.ThumbnailsPresent > 1),1,0)
   ?PreviewDelete{Prop:Disable} = Choose((SELF.ThumbnailsPresent > 1),1,0)
   ?PrintSingle{Prop:Disable} = Choose((SELF.ThumbnailsPresent > 1),1,0)
   
   END              !End Accept Loop
   SELF.MarkQueueKill
   SELF.ZoomQueueKill
   CLOSE(Preview:Window)
   RETURN(Self.ReturnValue)


TinReportViewer.PrintReport FUNCTION
RtnCode BYTE
! change, added option
Loc:RevQ    byte
! end change
PrintWindow WINDOW('Print Options'),AT(,,372,89),FONT('MS Sans Serif',8,,FONT:regular),CENTER,SYSTEM, |
         GRAY,AUTO
       OPTION('Print Ranges'),AT(6,2,107,65),USE(SELF.PrintingOption),BOXED,FONT('Arial',9,,FONT:regular)
         RADIO('All Pages'),AT(11,11),MSG('Print All Pages'),TIP('Print All Pages'),VALUE('1')
         RADIO('Marked Pages Only'),AT(11,21),USE(?OptionPrint:Marked),DISABLE,MSG('Print Marked Pages Only'), |
             TIP('Print Mark Pages Only'),VALUE('2')
         RADIO('Unmarked Pages Only'),AT(11,31),USE(?OptionPrint:UnMarked),DISABLE,MSG('Print Unmarked Pages Only'), |
             TIP('Print Unmarked Pages Only'),VALUE('3')
         RADIO('Range of Pages'),AT(11,41),MSG('Print A Range Of Pages'),TIP('Print A Range Of Pages'), |
             VALUE('4')
       END
       STRING('From:'),AT(22,52),FONT('Arial',8,,FONT:regular)
       SPIN(@N_3B),AT(41,54,26,8),USE(SELF.PageFrom,,?PageFrom),FONT('Arial',8,,FONT:regular),MSG('Select Starting Page'), |
           TIP('Select Starting Page'),RANGE(1,999),STEP(1)
       STRING('To:'),AT(68,52),FONT('Arial',8,,FONT:regular)
       SPIN(@N_3B),AT(80,54,26,8),USE(SELF.PageTo,,?PageTo),FONT('Arial',8,,FONT:regular),MSG('Select Ending Page'), |
           TIP('Select Ending Page'),RANGE(1,999),STEP(1)
       GROUP('Copies / Collate'),AT(123,35,219,26),USE(?Group1),BOXED
         STRING('Copies:'),AT(127,45),FONT('Arial',8,,FONT:regular)
         SPIN(@N_3B),AT(153,46,34,11),USE(SELF.PrintCopies),RIGHT,FONT('Arial',8,,FONT:regular),MSG('Select Number Of Copies'), |
             TIP('Select Number Of Copies'),RANGE(1,100),STEP(1)
         CHECK('Collate'),AT(197,46),USE(SELF.PrintCollate),FONT('Arial',8,,FONT:regular),MSG('Collate Report Copies'), |
             TIP('Collate Report Copies')
         CHECK('Printer Ejects Page Face Up'),AT(234,46),USE(Loc:RevQ)
       END
       STRING('Current Printer:'),AT(117,7),USE(?String2),FONT('Arial',8,,FONT:bold)
       STRING(@s50),AT(123,18,207,10),USE(SELF.SelectedPrinter)
       BUTTON,AT(331,15,16,16),USE(?SelectNewPrinter),LEFT,FONT('Arial',8,,FONT:regular),MSG('Select A Printer'), |
           TIP('Select A Printer'),ICON(ICON:Print1)
       BUTTON('OK'),AT(145,72,32,10),USE(?PrintOK),FONT('Arial',8,,FONT:regular),DEFAULT
       BUTTON('Cancel'),AT(195,72,32,10),USE(?PrintCancel),FONT('Arial',8,,FONT:regular)
     END

 CODE

  SELF.PrintingOption  = TinPrtOpt:AllPages
  SELF.SelectedPrinter = SELF.CurrentPrinter
  RtnCode = 0
  ! change, get default 
  Loc:RevQ = Self.GetEjectDir()
  ! end change
  OPEN(PrintWindow)
  IF SELF.PageMarked
    ?OptionPrint:Marked{Prop:Disable} = False
    ?OptionPrint:UnMarked{Prop:Disable} = False
  END
  ?PageFrom{Prop:RangeHigh} = RECORDS(SELF.ImageQueue)
  ?PageTo{Prop:RangeHigh}   = RECORDS(SELF.ImageQueue)
  ACCEPT
    IF SELF.PrintingOption = TinPrtOpt:RangeofPages THEN
      ?PageFrom{Prop:Disable} = False
      ?PageTo{Prop:Disable}   = False
    ELSE
      ?PageFrom{Prop:Disable} = True
      ?PageTo{Prop:Disable}   = True
    END
    CASE ACCEPTED()
      OF ?PrintOK
        RtnCode = True
        ! change, set page up or down
        Self.SetEjectDir(Loc:RevQ)
        ! end change
        POST(Event:CloseWindow)
      OF ?PrintCancel
        RtnCode = False
        POST(Event:CloseWindow)
      OF ?SelectNewPrinter
        X# = PRINTERDIALOG('Select A Printer',1)
        SELF.SelectedPrinter = PRINTER{PROPPRINT:Device}
    END
  END
  IF RtnCode !AND (CLIP(SELF.SelectedPrinter) <> CLIP(SELF.CurrentPrinter)) THEN  ! Change Tinman 05/18/99
    Setcursor(CURSOR:WAIT)
    Display()
    SELF.LoadTempImageQueue
    ! Change Tinman 05/18/99
    SELF.SetupCopiesCollate                                    ! Change Tinman 05/18/99
    ! End Change
    SELF.PrintOther
    Setcursor()
    Display()
    SELF.PreviewReport{PROP:FlushPreview} = False
!  ELSIF RtnCode AND SELF.PrintingOption <> TinPrtOpt:AllPages ! Change Tinman 05/18/99
!    SELF.DiscardPages                                         ! Change Tinman 05/18/99
!    SELF.PreviewReport{PROP:FlushPreview} = True              ! Change Tinman 05/18/99
  ELSE
    ! Change Tinman 07/16/99
    !!SELF.PreviewReport{PROP:FlushPreview} = False
    ! End Change
  END
  CLOSE(PrintWindow)
  RETURN(RtnCode)

TinReportViewer.DiscardPages PROCEDURE
MetaFileName        STRING(100),STATIC
TinRVMetafile       FILE,DRIVER('DOS'),NAME(MetaFileName),PRE(TinRVMetafile)
Record                RECORD,PRE()
MetaLine                STRING(256)
                      END
                    END

  CODE

  LOOP IDiscard# = RECORDS(SELF.ImageQueue) TO 1 BY -1
    IF SELF.PrintingOption = TinPrtOpt:MarkedPages OR SELF.PrintingOption = TinPrtOpt:UnmarkedPages
      GET(SELF.MarkQueue,IDiscard#)
      IF(SELF.PrintingOption = TinPrtOpt:MarkedPages AND SELF.MarkQueue.Mark) |
      OR(SELF.PrintingOption = TinPrtOpt:UnmarkedPages AND NOT SELF.MarkQueue.Mark)
        CYCLE
      .
    ELSE
      IF IDiscard# >= SELF.PageFrom AND IDiscard# <= SELF.PageTo
        CYCLE
    . .
    GET(SELF.ImageQueue,IDiscard#)
    MetaFileName = SELF.ImageQueue
    REMOVE(TinRVMetafile)
    DELETE(SELF.ImageQueue)
  END

TinReportViewer.PrintOther PROCEDURE
SingleReport REPORT,AT(1000,2000,6000,7000),PRE(RPT),THOUS
detail DETAIL
       END
     END

  CODE

  ! change
  Self.ReversePreviewQueue(Self.TempImageQueue)
  ! end change
  Printer{PropPrint:Copies} = 1
  OPEN(SingleReport)
  SingleReport{Prop:Text} = SELF.ReportTitle
  SingleReport{Prop:Landscape} = SELF.SaveLandscape
  SingleReport{Prop:preview} = SELF.TempImageQueue
  PRINT(rpt:detail)
  ENDPAGE(SingleReport)
  SingleReport{Prop:FlushPreview} = True
  CLOSE(SingleReport)

TinReportViewer.SaveSinglePage PROCEDURE
MetaFileName        STRING(100),STATIC
TinRVMetafile       FILE,DRIVER('DOS'),NAME(MetaFileName),PRE(TinRVMetafile)
Record                RECORD,PRE()
MetaLine                STRING(256)
                      END
                    END

 CODE

  IF NOT FILEDIALOG('Save Current Page to File...', |
                    SELF.TempFileName, |
                    'Text File|*.TXT|Windows MetaFile|*.WMF|All Files|*.*', |
                    file:save+file:keepdir+file:longname)
    Return
  END
  GET(SELF.ImageQueue,SELF.CurrentPage)
  IF INSTRING('.WMF',UPPER(SELF.TempFileName),1)
    MetaFileName = SELF.ImageQueue
    COPY(TinRVMetafile,SELF.TempFileName)
  ELSE
    FREE(SELF.TempImageQueue)
    SELF.TempImageQueue.FileName = SELF.ImageQueue
    ADD(SELF.TempImageQueue)
    SELF.SaveAsText
  END

TinReportViewer.SaveAsText PROCEDURE
TextFileName   STRING(100),STATIC
TinRVTxtfile   FILE,DRIVER('ASCII'),NAME(TextFileName),PRE(TinRVTxtfile),CREATE
Record          RECORD,PRE()
Line             STRING(220)
                END
               END
  CODE
  TextFileName = SELF.TempFileName
  Create(TinRVTxtfile)
  Open(TinRVTxtfile)
  Loop IC# = 1 To Records(SELF.TempImageQueue)
    GET(SELF.TempImageQueue,IC#)
!    wmf2asc(SELF.TempImageQueue.FileName,TinRVTxtfile,TinRVTxtfile:Record)
  End
  Close(TinRVTxtfile)

TinReportViewer.SaveAllPages PROCEDURE
SaveWindow WINDOW('Save All Pages to File...'),AT(,,372,89),FONT('MS Sans Serif',8,,FONT:regular),CENTER, |
         SYSTEM,GRAY,AUTO
       OPTION('Save Ranges'),AT(6,2,107,65),USE(SELF.PrintingOption),BOXED,FONT('Arial',9,,FONT:regular)
         RADIO('All Pages'),AT(11,11),MSG('Save All Pages'),TIP('Save All Pages'),VALUE('1')
         RADIO('Marked Pages Only'),AT(11,21),USE(?OptionPrint:Marked),DISABLE,MSG('Save Marked Pages Only'), |
             TIP('Save Mark Pages Only'),VALUE('2')
         RADIO('Unmarked Pages Only'),AT(11,31),USE(?OptionPrint:UnMarked),DISABLE,MSG('Save Unmarked Pages Only'), |
             TIP('Save Unmarked Pages Only'),VALUE('3')
         RADIO('Range of Pages'),AT(11,41),MSG('Save A Range Of Pages'),TIP('Save A Range Of Pages'), |
             VALUE('4')
       END
       STRING('From:'),AT(25,52),FONT('Arial',8,,FONT:regular)
       SPIN(@N_3B),AT(44,54,20,8),USE(SELF.PageFrom,,?PageFrom),FONT('Arial',8,,FONT:regular),MSG('Select Starting Page'), |
           TIP('Select Starting Page'),RANGE(1,999),STEP(1)
       STRING('To:'),AT(68,52),FONT('Arial',8,,FONT:regular)
       SPIN(@N_3B),AT(80,54,20,8),USE(SELF.PageTo,,?PageTo),FONT('Arial',8,,FONT:regular),MSG('Select Ending Page'), |
           TIP('Select Ending Page'),RANGE(1,999),STEP(1)
       STRING('File:'),AT(117,7),USE(?String2),FONT('Arial',8,,FONT:bold)
       STRING(@s50),AT(123,18,207,10),USE(SELF.TempFileName)
       BUTTON,AT(331,15,16,16),USE(?SelectNewFile),LEFT,FONT('Arial',8,,FONT:regular),MSG('Select A Printer'), |
           TIP('Select A Printer'),ICON(ICON:Pick)
       BUTTON('OK'),AT(145,72,32,10),USE(?SaveOK),FONT('Arial',8,,FONT:regular),DEFAULT
       BUTTON('Cancel'),AT(195,72,32,10),USE(?SaveCancel),FONT('Arial',8,,FONT:regular)
     END

 CODE

  SELF.TempFileName  = 'Save.txt'
  OPEN(SaveWindow)
  IF SELF.PageMarked
    ?OptionPrint:Marked{Prop:Disable} = False
    ?OptionPrint:UnMarked{Prop:Disable} = False
  END
  ?PageFrom{Prop:RangeHigh} = RECORDS(SELF.ImageQueue)
  ?PageTo{Prop:RangeHigh}   = RECORDS(SELF.ImageQueue)
  ACCEPT
    IF SELF.PrintingOption = TinPrtOpt:RangeofPages THEN
      ?PageFrom{Prop:Disable} = False
      ?PageTo{Prop:Disable}   = False
    ELSE
      ?PageFrom{Prop:Disable} = True
      ?PageTo{Prop:Disable}   = True
    END
    CASE ACCEPTED()
      OF ?SaveOK
        Setcursor(CURSOR:WAIT)
        Display()
        SELF.LoadTempImageQueue
        SELF.SaveAsText
        Setcursor()
        Display()
        POST(Event:CloseWindow)
      OF ?SaveCancel
        POST(Event:CloseWindow)
      OF ?SelectNewFile
        IF NOT FILEDIALOG('Save All Pages to File...', |
                    SELF.TempFileName, |
                    'Text File|*.TXT|All Files|*.*', |
                    file:save+file:keepdir+file:longname)
          Cycle
        END
    END
  END
  CLOSE(SaveWindow)

TinReportViewer.LoadTempImageQueue PROCEDURE
 CODE
    FREE(SELF.TempImageQueue)
    Loop IC# = 1 To Records(SELF.ImageQueue)
      GET(SELF.ImageQueue,IC#)
      SELF.TempImageQueue.FileName = SELF.ImageQueue
      ADD(SELF.TempImageQueue)
    End
    IF SELF.PrintingOption = TinPrtOpt:AllPages
      RETURN
    END
    LOOP IDiscard# = RECORDS(SELF.TempImageQueue) TO 1 BY -1
    IF SELF.PrintingOption = TinPrtOpt:MarkedPages OR SELF.PrintingOption = TinPrtOpt:UnmarkedPages
      GET(SELF.MarkQueue,IDiscard#)
      IF(SELF.PrintingOption = TinPrtOpt:MarkedPages AND SELF.MarkQueue.Mark) |
      OR(SELF.PrintingOption = TinPrtOpt:UnmarkedPages AND NOT SELF.MarkQueue.Mark)
        CYCLE
      .
    ELSE
      IF IDiscard# >= SELF.PageFrom AND IDiscard# <= SELF.PageTo
        CYCLE
    . .
    GET(SELF.TempImageQueue,IDiscard#)
    DELETE(SELF.TempImageQueue)
   END

TinReportViewer.CheckForPageNum PROCEDURE

PAGENUMOFWRK       STRING(19)
PREV:MetaFileName  STRING(100),Static
PREV:Metafile      FILE,DRIVER('dos'),NAME(PREV:MetaFileName)
Record              RECORD,PRE()
MetaLine             STRING(256)
                    END
                   END

 CODE

  LOOP TKCounter1# = 1 to SELF.ImageCount
    GET(SELF.ImageQueue, TKCounter1#)
    PREV:MetaFileName = SELF.ImageQueue
    OPEN(PREV:MetaFile)
    IF ERRORCODE(); CYCLE.
    TKMetaPointer# = 0
    LOOP
      SET(PREV:MetaFile, TKMetaPointer#)
      NEXT(PREV:MetaFile)
      TKCounter2# = instring('Page xxxxx of xxxxx', MetaLine, 1, 1)
      IF TKCounter2# > 0
        PAGENUMOFWRK = 'Strana:' & FORMAT(TKCounter1#,@s5)
        PAGENUMOFWRK = CLIP(PAGENUMOFWRK) & ' od ' & FORMAT(SELF.ImageCount,@s5)
        PAGENUMOFWRK = CENTER(CLIP(PAGENUMOFWRK),19)
        MetaLine = SUB(MetaLine,1,TKCounter2#-1)|
                     & PAGENUMOFWRK |
                     & SUB(MetaLine,TKCounter2#+19,LEN(MetaLine))
        PUT(PREV:MetaFile)
        BREAK
      END
      IF ERRORCODE() OR EOF(PREV:MetaFile); BREAK.
      TKMetaPointer# = POINTER(PREV:MetaFile) + 236     !This was originally   + 245
    END
    CLOSE(PREV:MetaFile)
  END

!-----------------------------------------------------------------------
! The Following Is Use To Check For Page Numbers If the View Is Not Use
!-----------------------------------------------------------------------
TinReportViewer.CheckForPageNum PROCEDURE(Queue ImageQueue)
PAGENUMOFWRK       STRING(19)
PREV:MetaFileName  STRING(100),Static
PREV:Metafile      FILE,DRIVER('dos'),NAME(PREV:MetaFileName)
Record              RECORD,PRE()
MetaLine             STRING(256)
                    END
                   END

 CODE

  SELF.ImageQueue &= ImageQueue
  SELF.ImageCount  = RECORDS(SELF.ImageQueue)

  LOOP TKCounter1# = 1 to SELF.ImageCount
    GET(SELF.ImageQueue, TKCounter1#)
    PREV:MetaFileName = SELF.ImageQueue
    OPEN(PREV:MetaFile)
    IF ERRORCODE(); CYCLE.
    TKMetaPointer# = 0
    LOOP
      SET(PREV:MetaFile, TKMetaPointer#)
      NEXT(PREV:MetaFile)
      TKCounter2# = instring('Page xxxxx of xxxxx', MetaLine, 1, 1)
      IF TKCounter2# > 0
        PAGENUMOFWRK = 'Page ' & FORMAT(TKCounter1#,@s5)
        PAGENUMOFWRK = CLIP(PAGENUMOFWRK) & ' of ' & FORMAT(SELF.ImageCount,@s5)
        PAGENUMOFWRK = CENTER(CLIP(PAGENUMOFWRK),19)
        MetaLine = SUB(MetaLine,1,TKCounter2#-1)|
                     & PAGENUMOFWRK |
                     & SUB(MetaLine,TKCounter2#+19,LEN(MetaLine))
        PUT(PREV:MetaFile)
        BREAK
      END
      IF ERRORCODE() OR EOF(PREV:MetaFile); BREAK.
      TKMetaPointer# = POINTER(PREV:MetaFile) + 236     !This was originally   + 245
    END
    CLOSE(PREV:MetaFile)
  END

TinReportViewer.JumpToPage FUNCTION(LONG Input:CurrentPage, LONG Input:TotalPages)
JumpPage    LONG
ReturnPage  LONG
JumpWindow WINDOW('Jump to a Report Page'),AT(,,181,26),FONT('MS Sans Serif',10,,),CENTER,STATUS,GRAY
       PROMPT('&Page:'),AT(5,8),USE(?JumpPrompt)
       SPIN(@n5),AT(30,7,50,12),MSG('Select a page of the report'),USE(JumpPage),STEP(1)
       BUTTON('OK'),AT(89,7,40,12),MSG('Jump to the selected page'),USE(?OKButton),DEFAULT
       BUTTON('Cancel'),AT(134,7,40,12),MSG('Cancel this selection'),USE(?CancelButton)
     END
  CODE
  JumpPage   = Input:CurrentPage
  ReturnPage = Input:CurrentPage
  OPEN(JumpWindow)
  ?JumpPage{Prop:RangeLow} = 1
  ?JumpPage{Prop:RangeHigh} = Input:TotalPages
  ACCEPT
    CASE ACCEPTED()
    OF ?OKButton
      ReturnPage = JumpPage
      BREAK
    OF ?CancelButton
      BREAK
    END
  END
  CLOSE(JumpWindow)
  RETURN(ReturnPage)

TinReportViewer.SelectDisplay PROCEDURE(*LONG Input:PagesAcross, *LONG Input:PagesDown)
SelectWindow WINDOW('Change the Report Display'),AT(,,141,64),FONT('MS Sans Serif',10,,),GRAY
       GROUP('Pages Displayed'),AT(3,2,135,43),USE(?Group1),BOXED
         GROUP('Across'),AT(7,10,62,32),BOXED
           SPIN(@N2),AT(13,22,50,12),USE(Input:PagesAcross),HSCROLL,RANGE(1,10),STEP(1)
         END
         GROUP('Down'),AT(72,10,62,32),BOXED
           SPIN(@N2),AT(79,22,50,12),USE(Input:PagesDown),HVSCROLL,RANGE(1,10),STEP(1)
         END
       END
       BUTTON('OK'),AT(98,47,40,14),KEY(EnterKey),USE(?OK),STD(STD:Close)
     END
  CODE
  OPEN(SelectWindow)
  ACCEPT
  END
  RETURN

!-----------------------------------------------------------------------
! The Following Is Use To Setup Copies / Collate By The Viewer
!-----------------------------------------------------------------------
TinReportViewer.SetupCopiesCollate PROCEDURE
 CODE
    !STOP('TinReportViewer.SetupCopiesCollate PROCEDURE')
    ! Called from Previewer CFW
    FREE(SELF.WorkImageQueue)
    Loop IC# = 1 To Records(SELF.TempImageQueue)
      GET(SELF.TempImageQueue,IC#)
      SELF.WorkImageQueue.FileName = SELF.TempImageQueue
      ADD(SELF.WorkImageQueue)
    End
    !If ~SELF.PrintCollate
    !  Copies# = SELF.PrintCopies
    !  PagesPerCycle# = 1
    !Else
    !  PagesPerCycle# = SELF.PrintCopies
    !  Copies# = 1
    !End
    !FREE(SELF.TempImageQueue)
    !Loop Copies# Times
    !  Loop IC# = 1 To Records(SELF.WorkImageQueue)
    !    GET(SELF.WorkImageQueue,IC#)
    !    SELF.TempImageQueue.FileName = SELF.WorkImageQueue
    !    Loop PagesPerCycle# times
    !      ADD(SELF.TempImageQueue)
    !    End
    !  End
    !End
    Copies# = SELF.PrintCopies
    PagesPerCycle# = 1
    FREE(SELF.TempImageQueue)
    If SELF.PrintCollate
      Loop IC# = 1 To Records(SELF.WorkImageQueue)
        GET(SELF.WorkImageQueue,IC#)
        SELF.TempImageQueue.FileName = SELF.WorkImageQueue
        Loop Copies# times     
          ADD(SELF.TempImageQueue)
        End                           
      End
    Else
      Loop Copies# Times
        Loop IC# = 1 To Records(SELF.WorkImageQueue)
          GET(SELF.WorkImageQueue,IC#)
          SELF.TempImageQueue.FileName = SELF.WorkImageQueue
          ADD(SELF.TempImageQueue)
        End
      End
    End

!-----------------------------------------------------------------------
! The Following Is Use To Setup Copies / Collate If The Viewer Is Not Called
!-----------------------------------------------------------------------
TinReportViewer.SetupCopiesCollate PROCEDURE(Queue ImageQueue)

 CODE

    !STOP('PROCEDURE(Queue ImageQueue)')
    ! Called from Print CFW
    If SELF.PrintCopies = 1 Then
      Return
    End
    FREE(SELF.WorkImageQueue)
    SELF.WorkImageQueue &= NEW TinPreviewQueue
    FREE(SELF.WorkImageQueue)
   !STOP('ImageQueue Records = ' & Records(ImageQueue))
    Loop IC# = 1 To Records(ImageQueue)
      GET(ImageQueue,IC#)
      SELF.WorkImageQueue.FileName = ImageQueue
      ADD(SELF.WorkImageQueue)
    End
    !STOP('Self.WorkImageQueue Records = ' & Records(Self.WorkImageQueue))
    !If SELF.PrintCollate
    !  Loop IC# = 1 To Records(SELF.WorkImageQueue)
    !    GET(SELF.WorkImageQueue,IC#)
    !    ImageQueue = SELF.WorkImageQueue
    !    Loop Copies# times
    !      ADD(ImageQueue)
    !    End
    !  End
    !Else
    !  Loop Copies# Times
    !    Loop IC# = 1 To Records(SELF.WorkImageQueue)
    !      GET(SELF.WorkImageQueue,IC#)
    !      ImageQueue = SELF.WorkImageQueue
    !      ADD(ImageQueue)
    !    End
    !  End
    !End
    FREE(ImageQueue)
    Copies# = SELF.PrintCopies
    PagesPerCycle# = 1
    FREE(SELF.TempImageQueue)
    If SELF.PrintCollate
      Loop IC# = 1 To Records(SELF.WorkImageQueue)
        GET(SELF.WorkImageQueue,IC#)
        ImageQueue = SELF.WorkImageQueue
        Loop Copies# times
          ADD(ImageQueue)
        End
      End
    Else
      Loop Copies# Times
        Loop IC# = 1 To Records(SELF.WorkImageQueue)
          GET(SELF.WorkImageQueue,IC#)
          ImageQueue = SELF.WorkImageQueue
          ADD(ImageQueue)
        End
      End
    End
    !STOP('ImageCue Records = ' & Records(ImageQueue))
    !
    Assert(~SELF.WorkImageQueue &= NULL)
    IF ~SELF.WorkImageQueue &= NULL
      FREE(SELF.WorkImageQueue)
      DISPOSE(SELF.WorkImageQueue)
    END
    !Self.DiscardPages
    !Self.PreviewReport{Prop:FlushPreview} = TRUE

TinReportViewer.PrintViewerSetup FUNCTION
Rtncode Byte
! change, added option
Loc:RevQ    byte,auto
! end change
Printoptwin WINDOW('Report Destination'),AT(,,317,92),FONT('MS Sans Serif',8,,FONT:regular),CENTER,SYSTEM, |
         GRAY,AUTO
       OPTION('ViewOptions'),AT(6,6,65,36),USE(SELF.PreviewOption),BOXED,FONT('Arial',8,COLOR:Black,FONT:regular)
         RADIO('View Report'),AT(12,15,54,11),USE(?TINPRINTOption1:Radio1),FONT('Arial',8,,FONT:regular), |
             MSG('View The Report'),TIP('View The Report'),VALUE('1')
         RADIO('Print Report'),AT(12,26),USE(?TINPRINTOPTION1:Radio2),FONT('Arial',8,,FONT:regular),MSG('Print The Report Without Viewing'), |
             TIP('Print The Report Without Viewing'),VALUE('2')
       END
       GROUP('Copies / Collate'),AT(6,46,111,43),USE(?Group1),BOXED
         STRING('Copies:'),AT(10,56),FONT('Arial',8,COLOR:Black,FONT:regular)
         SPIN(@N_3B),AT(36,56,31,11),USE(SELF.PrintCopies),RIGHT,FONT('Arial',8,,FONT:regular),MSG('Select Number Of Copies'), |
             TIP('Select Number Of Copies'),RANGE(1,100),STEP(1)
         CHECK('Collate'),AT(72,56,35,11),USE(SELF.PrintCollate),FONT('Arial',8,,FONT:regular),MSG('Collate Report Copies'), |
             TIP('Collate Report Copies')
         CHECK('Printer Ejects Page Face Up'),AT(10,73),USE(Loc:RevQ)
       END
       STRING('Current Printer:'),AT(80,8,,14),USE(?String2),FONT('Arial',8,,FONT:bold)
       STRING(@s50),AT(85,24,207,10),USE(SELF.CurrentPrinter)
       BUTTON,AT(293,21,16,16),USE(?SelectNewPrinter),LEFT,FONT('Arial',8,COLOR:Black,FONT:regular),MSG('Select A Printer'), |
           TIP('Select A Printer'),ICON(ICON:Print1)
       BUTTON('OK'),AT(169,74,44,13),USE(?OkPrtOpt),FONT('Arial',8,COLOR:Black,FONT:regular),MSG('Do It'), |
           TIP('Do It'),DEFAULT
       BUTTON('Cancel'),AT(219,74,44,13),USE(?CancelPrtOpt),FONT('Arial',8,COLOR:Black,FONT:regular), |
           MSG('Cancel Report'),TIP('Cancel Report')
     END

  CODE

  Rtncode = 0
  SELF.CurrentPrinter = PRINTER{PROPPRINT:Device}
  !Tinman 05/18/99
  SELF.PrintCollate = 0
  SELF.PrintCopies  = 1
  !Tinman 05/18/99
  ! change get current value
  Loc:RevQ = Self.GetEjectDir()
  ! end change
  OPEN(Printoptwin)
  Display()
  ACCEPT
    CASE ACCEPTED()
      OF ?OkPrtOpt
        IF SELF.PreviewOption = TinViewOpt:ViewReport THEN
          SELF.SkipPreview = 0
        ELSE
          SELF.SkipPreview = 1
        END
        !Tinman 05/18/99 The following will only work without the viewer if the printer supports it
        PRINTER{PROPPRINT:COLLATE} = SELF.PrintCollate
        PRINTER{PROPPRINT:COPIES}  = SELF.PrintCopies
        !Tinman 05/18/99
        POST(Event:CloseWindow)
      OF ?CancelPrtOpt
        Rtncode = 1
        POST(Event:CloseWindow)
       OF ?SelectNewPrinter
        X# = PRINTERDIALOG('Select A Printer',1)
        SELF.CurrentPrinter = PRINTER{PROPPRINT:Device}
     END
  END
  Self.SetEjectDir(Loc:RevQ)
  CLOSE(Printoptwin)
  RETURN(Rtncode)

! -------------------------------------------------------------------------------
! change, added three methods
TinReportViewer.ReversePreviewQueue PROCEDURE(TinPreviewQueue Q)
! method to step thru the Q passed and reverse the elements
!
NumInQueue   byte,auto       ! local workers
Counter      byte,auto
WorkImageQueue &TinPreviewQueue

  code 

  ! if at least two records and the flag is set to reverse
  NumInQueue = records(Q)    ! how many
  if (NumInQueue > 1) and (Self.EjectPageUpDown = TinEject:PageFaceUp)
    ! get new queue and step thru last to first
    WorkImageQueue &= new(TinPreviewQueue)
    loop Counter = NumInQueue to 1 by -1
      get(Q, Counter)
      ! assign value to temp queue and add it to the temp
      WorkImageQueue.FileName = Q.FileName
      add(WorkImageQueue)
    end
    ! move values back from temp queue to q passed
    ! from 1 to last this pass
    loop Counter = 1 to NumInQueue
      get(WorkImageQueue, Counter)   ! get each queue element
      get(Q, Counter)
      Q.FileName = WorkImageQueue.FileName ! move from temp to passed Q
      put(Q)        ! store it
    end
    ! dump the temp queue 
    free(WorkImageQueue)
    dispose(WorkImageQueue)
  end

  return
! -------------------------------------------------------------------------------

TinReportViewer.SetEjectDir  procedure(byte Flag = TinEject:PageFaceUp)
! set the flag to indicate that the image queue is to be reveresed or not 
  code

  Self.EjectPageUpDown = flag

  return
! --------------------------------------------------------------------------------

TinReportViewer.GetEjectDir  procedure()  ! byte
! set the flag to indicate that the image queue is to be reveresed or not 
  code

  return(Self.EjectPageUpDown)

! --------------------------------------------------------------------------------

! end change